;==============================================================================
pro Shape::PrintColor

self->GetProperty, color=color
print,'_____________________________'
print,'My color is:   R=',color[0],'    G=',color[1],'    B=',color[2]

end


;==============================================================================
pro Shape::PrintPerimeter

print,'_____________________________'
print,'My perimeter is: ',self.perimeter

end


;==============================================================================
pro Shape::PrintArea

print,'_____________________________'
print,'My area is: ',self.area

end


;==============================================================================
pro Shape::SetProperty, color=color

if (n_elements(color) eq 3) then begin
    ; color must be a 3-element vector
    self.color = color
endif

end


;==============================================================================
pro Shape::GetProperty, area=area, perimeter=perimeter, color=color

if (arg_present(area)) then $
    area = self.area

if (arg_present(perimeter)) then $
    perimeter = self.perimeter

if (arg_present(color)) then $
    color = self.color

end


;==============================================================================
; The Constructor
; Called during the initialization of objects of this class
function Shape::Init, _REF_EXTRA=etc

; set default data member values
self.area = 0.0
self.perimeter = 0.0
self.color = [0,0,0]

if (n_elements(etc) gt 0) then self->setProperty, _EXTRA=etc

return, 1

end


;==============================================================================
; The Destructor
; Called whenever an object of this class is destroyed
pro Shape::Cleanup

; no heap variables to free
; or any other tidying up to do
end


;==============================================================================
; Class structure declaration
; Defines the data members or variables for an object of this class
; Shape is an "abstract" class which includes all geometric objects
; The only properties we are certain it should have are area, perimeter and color!
pro Shape__define

struct = {Shape $
          ,area:0.0 $
          ,perimeter:0.0 $
          ,color:[0b,0b,0b] $
         }

end